import React, { useState, useEffect, forwardRef } from 'react';
import WangEditor from './OneStopWangEditor';

function Index({ onChange, value, otherProps, dataColumn, disabled }) {
  const [ready, setReady] = useState(false);
  const domKey = dataColumn.base52 || 'wang-editor-dom-content';
  useEffect(() => {
    let dom = document.getElementById(`wangEditor${domKey}`);
    if(dom && dom.parentNode){
      dom.parentNode.removeChild(dom);
    }
    setReady(true);
  }, []);

  if(!ready){
    return null;
  }
  return (
    <WangEditor
      key={'cmsContent'}
      height={otherProps?.height || 450}
      value={value || ''}
      domKey={dataColumn.base52 || 'wang-editor-dom-content'}
      onChangeValue={onChange}
      otherProps={otherProps}
    />
  );
}

export default forwardRef((props, _ref) => {
  let otherProps = {};
  if(!props.json || typeof props.json.initialValue === 'undefined'){
    return <div></div>;
  }
  if (props.json?.otherProps) {
    otherProps = props.json?.otherProps;
    try {
      otherProps = new Function(otherProps)();
      // console.log(this.otherProps);
    } catch (e) {

    }
  }
  return <Index {...props} otherProps={otherProps}/>;
});
